include<nuts_and_bolts.scad>;
include<nema17.scad>;
include<Threading.scad>;
widthinside=100;
lengthbottom=370;
semiheight=885;
fullheight=885;
beamwidth=20;
partdistance=220;
microplatex=240;
microplatex2=30;
microplatey=53.5/2;
microplatez=135;
zposition=500;
riserx=90;
zheight=550;
motorlength=43.2;
motorscrewsep=31;
gantrywidth=50;
gantryspacing=2.5;
gantrythickness=5;
module linearBearing(){
    
}



module microplate(){
    width=86.5;
    length=127.8;
    height=20;
    % cube([length,width,height]);
}
module beam(length,dir="z"){
    if(dir=="z")
translate([10,10,0])linear_extrude(height=length)scale([1.33333333,1.33333333,1.3333333])import("openbeam.dxf");
      if(dir=="x")
translate([0,10,10])rotate([0,90,0])linear_extrude(height=length)scale([1.33333333,1.33333333,1.3333333])import("openbeam.dxf");
      if(dir=="y")
translate([10,0,10])rotate([-90,0,0])linear_extrude(height=length)scale([1.33333333,1.33333333,1.3333333])
import("openbeam.dxf");
}

module mainStructure(){
translate([0,0,0])beam(lengthbottom,"x");
translate([0,widthinside+beamwidth,0])beam(lengthbottom,"x");
    translate([0,0,fullheight+beamwidth])beam(partdistance+beamwidth*2,"x");
translate([0,widthinside+beamwidth,fullheight+beamwidth])beam(partdistance+beamwidth*2,"x");
    translate([partdistance+beamwidth*2,0,semiheight+beamwidth])beam(lengthbottom-partdistance-beamwidth*2,"x");
translate([partdistance+beamwidth*2,widthinside+beamwidth,semiheight+beamwidth])beam(lengthbottom-partdistance-beamwidth*2,"x");
    
translate([0,0,beamwidth])beam(fullheight,"z");

translate([0,widthinside+beamwidth,beamwidth])beam(fullheight,"z");
translate([beamwidth+partdistance,0,beamwidth])beam(fullheight,"z");

translate([beamwidth+partdistance,widthinside+beamwidth,beamwidth])beam(fullheight,"z");

translate([lengthbottom-beamwidth,0,beamwidth])beam(semiheight,"z");
translate([lengthbottom-beamwidth,widthinside+beamwidth,beamwidth])beam(semiheight,"z");

translate([0,beamwidth,0])beam(widthinside,"y");
translate([lengthbottom-beamwidth,beamwidth,0])beam(widthinside,"y");
    
    translate([0,beamwidth,fullheight+beamwidth])beam(widthinside,"y");
    translate([partdistance+beamwidth,beamwidth,fullheight+beamwidth])beam(widthinside,"y");
translate([lengthbottom-beamwidth,beamwidth,semiheight+beamwidth])beam(widthinside,"y");

//translate([microplatex2,microplatey,microplatez])color("green") microplate();



translate([riserx,0,beamwidth])beam(fullheight,"z");

}


//translate([riserx-motorlength,0,20])

module motorHolder(){
    difference(){

    union(){
    cube([motorlength,motorlength,8]);
        cube([10,20,20]);
        translate([-beamwidth,beamwidth,0])cube([30,10,20]);
    }
    
    translate([motorlength/2-motorscrewsep/2,motorlength/2-motorscrewsep/2,0])cylinder(10,1.5,1.5);
      translate([motorlength/2-motorscrewsep/2,motorlength/2-motorscrewsep/2,4])cylinder(40,3,3);
    translate([motorlength/2+motorscrewsep/2,motorlength/2-motorscrewsep/2,0])cylinder(10,1.5,1.5);
      translate([motorlength/2+motorscrewsep/2,motorlength/2+motorscrewsep/2,0])cylinder(10,1.5,1.5);
    translate([motorlength/2-motorscrewsep/2,motorlength/2+motorscrewsep/2,0])cylinder(10,1.5,1.5);
    translate([motorlength/2,motorlength/2,0])cylinder(2,22.3/2,22.3/2);
     translate([motorlength/2,motorlength/2,0])cylinder(20,5,5);
   translate([0,10,15]) rotate([0,90,0])cylinder(100,2.5,2.5);
     translate([-10,0,15]) rotate([-90,0,0])cylinder(100,2.5,2.5);
};
};

module bearingHolder(){
    difference(){

    union(){
        translate([0,0,10])
    cube([35,40,9]);
        cube([10,20,20]);
        translate([-beamwidth,beamwidth,0])cube([30,10,20]);
    }
    
   
   //# translate([motorlength/2,motorlength/2,0])cylinder(2,22.1/2,22.3/2);
     translate([motorlength/2,motorlength/2,0])cylinder(20,22.1/2,22.1/2);
   translate([0,10,6]) rotate([0,90,0])cylinder(100,2.5,2.5);
     translate([-10,0,6]) rotate([-90,0,0])cylinder(100,2.5,2.5);
};
};


module gantry(){
    difference(){
    cube([gantrywidth,gantrythickness,gantrywidth]);
  translate([gantrywidth/2,0,gantrywidth/2]) rotate([-90,0,0])cylinder(100,5/2,5/2);
        
        translate([gantrywidth/2,0,gantrywidth/2+10]) rotate([-90,0,0])cylinder(100,5/2,5/2);
          translate([gantrywidth/2,0,gantrywidth/2-10]) rotate([-90,0,0])cylinder(100,5/2,5/2);
         translate([gantrywidth/2-10,0,gantrywidth/2]) rotate([-90,0,0])cylinder(100,5/2,5/2);
         translate([gantrywidth/2+10,0,gantrywidth/2]) rotate([-90,0,0])cylinder(100,5/2,5/2);
        
        
        
    }
}

module zcarriage(){
    zthickness=10;
    difference(){
    cube([gantrywidth,zthickness,gantrywidth]);
  translate([gantrywidth/2,0,gantrywidth/2]) rotate([-90,0,0])cylinder(100,5/2,5/2);
        
        translate([gantrywidth/2,0,gantrywidth/2+10]) rotate([-90,0,0])cylinder(100,5/2,5/2);
          translate([gantrywidth/2,0,gantrywidth/2-10]) rotate([-90,0,0])cylinder(100,5/2,5/2);
         translate([gantrywidth/2-10,0,gantrywidth/2]) rotate([-90,0,0])cylinder(100,5/2,5/2);
         translate([gantrywidth/2+10,0,gantrywidth/2]) rotate([-90,0,0])cylinder(100,5/2,5/2);
        
        
        
    }
    bottom=10;
    difference(){
    translate([gantrywidth-12,-beamwidth-gantryspacing-gantrythickness,-bottom])cube([20+12,38,bottom]);
    translate([0,0,-bottom])
 cube([gantrywidth-5,zthickness,bottom]);
      

    translate([-riserx-beamwidth/2+gantrywidth/2,-beamwidth-gantryspacing-gantrythickness,-20])
translate([riserx+beamwidth,0,0])translate([motorlength/2,motorlength/2,0])cylinder(500,5.13,5.13);
    translate([-riserx-beamwidth/2+gantrywidth/2,-beamwidth-gantryspacing-gantrythickness,-20])
        translate([8,0,0])
    translate([riserx+beamwidth,0,0])translate([motorlength/2,motorlength/2,0])cylinder(25,1.5,1.5);
        translate([-riserx-beamwidth/2+gantrywidth/2,-beamwidth-gantryspacing-gantrythickness,-20]) 
         translate([-8,0,0])
    translate([riserx+beamwidth,0,0])translate([motorlength/2,motorlength/2,0])cylinder(25,1.5,1.5);
        
         translate([-riserx-beamwidth/2+gantrywidth/2,-beamwidth-gantryspacing-gantrythickness,-20]) 
         translate([0,8,0])
    translate([riserx+beamwidth,0,0])translate([motorlength/2,motorlength/2,0])cylinder(25,1.5,1.5);
         translate([-riserx-beamwidth/2+gantrywidth/2,-beamwidth-gantryspacing-gantrythickness,-20]) 
         translate([0,-8,0])
    translate([riserx+beamwidth,0,0])translate([motorlength/2,motorlength/2,0])cylinder(25,1.5,1.5);
         translate([-riserx-beamwidth/2+gantrywidth/2,-beamwidth-gantryspacing-gantrythickness,-20]) 
        translate([0,0,0])
    translate([riserx+beamwidth,0,0])translate([motorlength/2,motorlength/2,0])cylinder(11,11.1,11.1);
        
        
    }
    translate([0,0,-10])
    cube([gantrywidth-4,zthickness,10]);
    translate([-30,0,-20])
    cube([10,70,40]);
     translate([motorlength,0,-5])
    cube([10,70,35]);
    
   color("brown") translate([-74,10+50,10])
  difference(){  cube([74,10,20]);
      translate([16/2+2,0,20-16/2-3])
      rotate([-90,0,0])cylinder(2000,6/2,6/2);
  }
  /*
   color("brown") translate([motorlength,10+50,10])
  difference(){  cube([108,10,20]);
      translate([108-16/2-4,0,20-16/2-3])
      rotate([-90,0,0])cylinder(2000,6/2,6/2);
  }*/
    
    
   color("red") translate([-73,10+50,gantrywidth-motorlength-30-15])
    difference(){
    cube([motorlength,10,motorlength]);
        translate([motorlength/2-motorscrewsep/2,0,motorlength/2-motorscrewsep/2])rotate([-90,0,0])cylinder(30,1.5,1.5);
        translate([motorlength/2+motorscrewsep/2,0,motorlength/2-motorscrewsep/2])rotate([-90,0,0])cylinder(30,1.5,1.5);
        translate([motorlength/2+motorscrewsep/2,0,motorlength/2+motorscrewsep/2])rotate([-90,0,0])cylinder(30,1.5,1.5);
        translate([motorlength/2-motorscrewsep/2,0,motorlength/2+motorscrewsep/2])rotate([-90,0,0])cylinder(30,1.5,1.5);
         translate([motorlength/2,0,motorlength/2])rotate([-90,0,0])cylinder(30,11.1,11.1);
        
    }
    /*   difference(){translate([105,30,gantrywidth-motorlength-30+motorlength])
  cube([20,30,10]);
      translate([114,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(85,2.5,2.5);
       }*/
   translate([-55,0,gantrywidth-motorlength-30+motorlength-15])
  difference(){union(){cube([65,70,15]);
      translate([0,30,0])cube([20,20,25]);
  }
      translate([60,38,0])cube([10,10,25]);
       translate([10,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(85,2.5,2.5);
      translate([10,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(5,6,6);
  }
       
    difference(){translate([0,35,gantrywidth-motorlength-30+motorlength])
  cube([gantrywidth,60-25,10]);
      translate([8,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(100,2.5,2.5);
          translate([38,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(100,2.5,2.5);
          translate([8,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(24,6,6);
          translate([38,-gantryspacing-gantrythickness+widthinside/2,0])cylinder(24,6,6);
  }
    
  
   translate([-70,0-20-7.5+25,63]) cube([16,23,8]);
 translate([-70+15,2.5-20-7.5+25,13]) cube([16,6,57]);
  
   translate([-70,20,63])
  {
      difference(){
      cube([16,39.5,4]);
          translate([16-3,3.5,0]) nutHole(3);
          translate([16-3,3.5+19,0]) nutHole(3);
             translate([16-3,3.5,0]) cylinder(10,1.5);
          translate([16-3,3.5+19,0]) cylinder(10,1.5);
      }
  }
  
}

//color("blue")translate([riserx+beamwidth/2-gantrywidth/2,beamwidth+gantryspacing,80])gantry();


module angle(){
    color("brown") translate([-74,10+50,10])
  difference(){  translate([4,-27,0])cube([34,37,20]);
      translate([0,-05,0]) cube([20,20,20]);
      
      
      translate([16/2+2+22,-40,20-16/2-3])
      rotate([-90,0,0])cylinder(2000,6/2,6/2);
      translate([10,-17.5,0])cylinder(85,2.5,2.5);
      translate([25,-17.5,0])cylinder(85,2.5,2.5);
  }
  };
  
  color("gray")translate([0,widthinside/2+beamwidth-beamwidth/2,zheight+30])beam(230,"x");
  color("orange")translate([riserx+beamwidth/2-gantrywidth/2,beamwidth+gantryspacing+gantrythickness,zheight])zcarriage();


  color("orange")translate([190+riserx+beamwidth/2-gantrywidth/2,beamwidth+gantryspacing+gantrythickness,zheight])angle();
  

color("red")  translate([riserx+beamwidth,0,60])motorHolder();
color("red") translate([riserx+beamwidth,0,fullheight-20])bearingHolder();


 color("lightgray") translate([riserx+beamwidth,0,60])translate([motorlength/2,motorlength/2,0])threading(pitch = 4, d=8, windings=207, full=true); 
  
  translate([riserx+beamwidth,0,60])translate([motorlength/2,motorlength/2,0])nema_17();
  
   translate([0,90,zheight+5])rotate([-90,0,0])translate([motorlength/2,motorlength/2,0])nema_17();


% mainStructure();
  translate([microplatex,microplatey,microplatez]) microplate();
translate([0,beamwidth+widthinside/2-35,zheight+50+7.5])color("gray")cube([225,70,2]);

color("darkblue")translate([20,107,zheight+27])rotate([0,0,-90])import("beltattachmentA.stl");
module upright(){
    for(i = [0:3]){
        translate([0,0,i*198])
    import("plateholder.stl");
    }
    
};
color("black")translate([240,20,90])rotate([0,0,0]) upright();
color("black")translate([350,20,90])rotate([0,0,0]) upright();
color("black")translate([260,120,90])rotate([0,0,180]) upright();
color("black")translate([370,120,90])rotate([0,0,180]) upright();
